/////////////////////////////////////////////////////////////////////////////
// Name:        Server.h
// Purpose:     Store the server parameters here
// Author(s):   Atul, Ashesh
// Created:     2008-07-08
// RCS-ID:      $Id: Server.h,v 1.5 2008/08/18 14:18:35 asheshv Exp $
// Copyright:   (c) EnterpriseDB
/////////////////////////////////////////////////////////////////////////////

#ifndef _SERVER_H
#define _SERVER_H

// wxWindows headers
#include <wx/wx.h>
#include "WSUtils.h"

enum ServerType
{
    SVR_POSTGRESQL = 0,
    SVR_ENTERPRISEDB
};

enum ServerUtiltizationType
{
    SVR_UTILI_DEV = 0,
    SVR_UTILI_MIX,
    SVR_UTILI_DED
};

enum WorkloadProfileType
{
    WORKLOAD_PROF_TP = 0,
    WORKLOAD_PROF_GEN,
    WORKLOAD_PROF_REP
};

const char * const g_svr_utilization[] = {"Development", "Mixed", "Dedicated"};
const char * const g_svr_utilizaton_value[] = {"33", "66", "100"};

const char * const g_workload_profile[] = {"Transaction Processing", "General Purpose", "Reporting"};
const char * const g_workload_profile_value[] = {"oltp", "mixed", "reporting"};

#define PG_SVR_WORKLOAD_PROF_TP "oltp"

class Server;

class ServerConfigData {
public:
    void SetValue(wxString &prop, wxString &value);
private:
    wxString m_parameter_value[DYNATUNE_CONFIG_LEN];
    static const wxString ms_parameters[DYNATUNE_CONFIG_LEN];
    static bool ms_ConfigFlags[DYNATUNE_CONFIG_LEN];
    friend class Server;
};

class Server : public wxClientData
{
    public:
        long m_port;
        wxString m_description;
        long m_majorVer;
        long m_minorVer;
        int m_serverType;
	
        wxString m_installationPath;
        wxString m_dataDirectory;
        wxString m_serverVersion;
        wxString m_serviceId;
        wxString m_superuserName;
        wxString m_serviceAccount;
        wxString m_encoding;
        wxString m_locale;
        ServerConfigData m_cfgData;
        wxString GetPostgreSQLConfig();
        wxString UpdateConfigBuffer( wxString buffer, 
            wxString& matched_parameter, wxString& original_value,
            wxString& new_value);
        wxString GetNextNonUpdatedConfiguration();
        void ClearConfigFlags();
};

#endif


