/////////////////////////////////////////////////////////////////////////////
// Name:        SysInfoPage.h
// Purpose:     Wizard page for gathering system info (workload profile, 
//				server utilization
// Author(s):   Atul, Ashesh
// Created:     2008-07-08
// RCS-ID:      $Id: SysInfoPage.h,v 1.5 2008/07/31 08:25:19 asheshv Exp $
// Copyright:   (c) EnterpriseDB
/////////////////////////////////////////////////////////////////////////////

#ifndef _SYSINFOPAGE_H
#define _SYSINFOPAGE_H

#include "TuningTool.h"
#include "Server.h"

// wxWindows headers
#include <wx/wx.h>
#include <wx/wizard.h>
#include <wx/button.h>
#include <wx/progdlg.h>

class SysInfoPage : public wxWizardPageSimple
{
public:
    SysInfoPage(wxWizard *parent);
    virtual void OnWizardPageChanging(wxWizardEvent& event);
	void OnUtilizationTypesClicked(wxCommandEvent &event);
	void OnWorkloadProfileClicked(wxCommandEvent &event);
    int GetServerUtillization() const { return m_serverUtilization->GetSelection();}
    int GetDBMSUsage() const { return 0;} // always return OLTP
    bool CallWebservice(Server *server, int svr_utilization, int workload_profile);
    bool UpdateServerConfiguration();

private:
	wxRadioBox *m_workloadProfile;
	wxRadioBox *m_serverUtilization;
    wxProgressDialog *m_progress;
    void InitProgressBar(bool show);
    void UpdateProgressBar(int value, wxString status);
	static const wxString m_utilizationTypesHelpText[3];
	wxStaticText *m_utilizationTypeDefaultHelpText;

	static const wxString m_workloadProfileHelpText[3];
	wxStaticText *m_workloadProfileDefaultHelpText;
	DECLARE_EVENT_TABLE()
};

#endif
