/////////////////////////////////////////////////////////////////////////////
// Name:        WelcomePage.h
// Purpose:     Wizard page for greeting the user and detecting any 
//				server installation
// Author(s):   Atul, Ashesh
// Created:     2008-07-08
// RCS-ID:      $Id: WelcomePage.h,v 1.6 2008/08/18 14:18:35 asheshv Exp $
// Copyright:   (c) EnterpriseDB
/////////////////////////////////////////////////////////////////////////////

#ifndef _WELCOMEPAGE_H
#define _WELCOMEPAGE_H

#include "TuningTool.h"
#include "FileSelectorCombo.h"
#include "Server.h"

// wxWindows headers
#include <wx/wx.h>
#include <wx/wizard.h>
#include <wx/button.h>

class WelcomePage : public wxWizardPageSimple
{
public:
    WelcomePage(wxWizard *parent);
    virtual void OnWizardPageChanging(wxWizardEvent& event);
    inline bool IsInstallationDetected() const {return m_installationDetected;}
    inline Server *GetSelectedServer()
    {
        if (!m_installationDetected)
            return &m_EmptyServer;
        else
            return
                (Server *)(m_installation->GetClientObject(
                                             m_installation->GetSelection()));
    }
    inline wxString GetFilename() const {return m_fileSelector->GetFilename();}
    inline wxString GetDirectory() const {return m_fileSelector->GetDirectory();}
    inline wxString GetPath() const {return m_fileSelector->GetPath();}

private:
    bool m_installationDetected;
    FileSelectorCombo* m_fileSelector;
    wxComboBox *m_installation;

    bool IsValidPGServer(Server *server);
    bool FindPgServers();
    bool FindEdbServers();

    void OnProxies(wxCommandEvent& event);    
    wxButton *m_proxies;
    Server    m_EmptyServer;

    DECLARE_EVENT_TABLE()
};

#endif
